
// ======================================================
//
// RTOS_Rel_2
// CBP 11-03-22
// Mod 20-03-23 use unsigned longs for counters
// Blinking LEDs with print-out of Idle Ticks
//
// ======================================================

#include <Arduino_FreeRTOS.h>

volatile uint64_t idleCount1 = 0;
volatile uint64_t idleCount2 = 0;

void setup() {
  Serial.begin(115200);
  Serial.println(F("In Setup function"));
  pinMode(4,OUTPUT);
  pinMode(5,OUTPUT);
  xTaskCreate(MyTask1, "Task1", 200, NULL, 1, NULL);
  xTaskCreate(MyTask2, "Task2", 200, NULL, 1, NULL);  
}

void loop(){
  // DO nothing
}


static void MyTask1(void* pvParameters){

  while(1) {
    cprintf("Task 1 running preceded by %l idle calls\n",idleCount1);
 
    // Reset idleCount ready for next iteration
    idleCount1 = 0;    
    
    digitalWrite(4,HIGH);
    delay(1000);
    digitalWrite(4,LOW);   
    delay(1000);
    
  }
}

static void MyTask2(void* pvParameters){
  while(1) {
    cprintf("Task 2 running preceded by %l idle calls\n",idleCount2);

    // Reset idleCount ready for next iteration
    idleCount2 = 0;    
    digitalWrite(5,HIGH);
    delay(1000);
    digitalWrite(5,LOW);   
    delay(1000);
  }
}

// The Idle Task calls this each iteration of the Idle loop
// Here we just count the number of times it is called.
void vApplicationIdleHook(void) {
    idleCount1++;
    idleCount2++;
}
