// ==================================================================================
//
// RTOS_Subsumption_Rel
//
// Student Release
// Template for Robot Subsumption Architecture
// Based on RTOS_Subsumption_Devel_2
// CBP 12-03-22
// ==================================================================================

#include <Arduino_FreeRTOS.h>
#include <timers.h>
#include <Servo.h>

#define HC_SR04_SET_AND_FIRE(cycles) {uint8_t m=0xff-(cycles-1); OCR2B=m;TCNT2 =m-1;}
#define HC_SR04_SET_WIDTH(cycles) (OCR2B = 0xff-(cycles-1))
#define RxPin 2
#define TxPin 9
#define DEBUG false

volatile unsigned long startTime;
volatile unsigned long endTime;
volatile boolean finished = true;
volatile float dist = 1000;

Servo servoLeft;
Servo servoRight;
volatile int driveL,driveR;
volatile int evadeDriveL, evadeDriveR;
volatile int wanderDriveL, wanderDriveR;
volatile boolean evade_flag = false;

BaseType_t xTimer2Started;
TimerHandle_t xTimer2;
    
void setup() {  

    Serial.begin(115200);
    Serial.println(F("In Setup function"));
    pinMode(9,OUTPUT);
    pinMode(2,INPUT);
    servoLeft.attach(12);
    servoRight.attach(13);

    // (1) Create an Evade Task. Look at RTOS_MotorTest_Rel for help

    // (2) Create a Wander Task

    // (3) Create an Arbitrate Task

    // (4) Create a Monitor Task
   
    // (5) Attach interrupt to pin2 to get echo pulse from Ultrasonic
    // Look at RTOS_USonic_Rel for help
    
    // (6) Create a timer and start it to fire the Ultrasonic ping
    // Look at RTOS_USonic_Rel for help   

}

// (7) Write the Monitor task function. Remember to wrap this in while(){   }
// and to include a call to vTaskDelay()
// Function should send driveL and driveR to the serial monitor and also
// the value of evade_flag. Look at RTOS_MotorTest_Rel for help.

// (8) Create Arbitrate task function to set driveL and driveR using wanderDriveL
// or evadeDriveL (and Right) depending on the value of evade_flag

// (9) Write an Evade Task function. This should set the velocities you wish
// and delay a time. You could use a series of movements.
// Set the evade flag to true if dist is below some threshold. Set the
// evade flag to false as appropriate (there are 2 cases to consider
// Look at RTOS_MotorTest_Rel for help

// (10) Create a Wander Task function setting a series of movements. For each
// movement set the values of wanderDriveL etc, and call vTaskDelay() to
// set the duration of each movement. Look at RTOS_MotorTest_Rel for help

// (11) Put the USonic timer CallBack function here. Grab the code from
// RTOS_USonic_Rel

void loop() {

}

// (12) Put the USonic interrupt service routine in here. Grab this from
// RTOS_USonic_Rel

// Here's the code to get the hardware timer working to drive the
// USonic device with its 10 mu-second pulses.
void pulseSetup(uint8_t cycles) {
  finished = false;
  TCCR2B =  0;   
  TCNT2 = 0x00; 
  OCR2A = 0;     
  HC_SR04_SET_WIDTH(cycles); 
  TCCR2A = _BV(COM2B0) | _BV(COM2B1) | _BV(WGM20) | _BV(WGM21); 
  TCCR2B = _BV(WGM22)| _BV(CS20);   
}
