// ==========================================================
//
// CBP_2403_Helper1.ino
//
// Stuff to get printf working Call function cprint to avoid
// conflict with any printf included
// CBP 09-09-21
// Status: Workaround but it works
//
// =========================================================

void cprintf(const char* format, ...) { 
    va_list argv;
    va_start(argv, format);

    for (int i = 0; format[i] != '\0'; i++) {
        if (format[i] == '%') {
            int places = 2;
            if (format[i+1] == '.') i++;  
            if (format[i+1] >= '0' && format[i+1] <= '9') {
                places = format[i+1] - '0';
                i++;
            }
            
            switch (format[++i]) {
                case 'B':
                    Serial.print("0b"); // Fall through intended
                case 'b':
                    Serial.print(va_arg(argv, int), BIN);
                    break;
                case 'c': 
                    Serial.print((char) va_arg(argv, int));
                    break;
                case 'd': 
                case 'i':
                    Serial.print(va_arg(argv, int), DEC);
                    break;
                case 'f': 
                    Serial.print(va_arg(argv, double), places);
                    break;
                case 'l': 
                    Serial.print(va_arg(argv, long), DEC);
                    break;
                case 'o':
                    Serial.print(va_arg(argv, int) == 0 ? "off" : "on");
                    break;
                case 's': 
                    Serial.print(va_arg(argv, const char*));
                    break;
                case 'X':
                    Serial.print("0x"); // Fall through intended
                case 'x':
                    Serial.print(va_arg(argv, int), HEX);
                    break;
                case '%': 
                    Serial.print(format[i]);
                    break;
                default:
                    Serial.print("?");
                    break;
            }
        } else {
            Serial.print(format[i]);
        }
    }
    va_end(argv);
}
